# Create Product Parameter

Create a product parameter.

## POST /public/v1/catalog/products/{productId}/parameters

>

```json
{"openapi":"3.0.1","info":{"title":"Marketplace API","version":"5.0.5287-g2eed84b0"},"servers":[{"url":"https://api.platform.softwareone.com"}],"paths":{"/public/v1/catalog/products/{productId}/parameters":{"post":{"tags":["Parameters"],"parameters":[{"name":"productId","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/CreateParameterDefinitionRequest"}]}},"text/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/CreateParameterDefinitionRequest"}]}},"application/*+json":{"schema":{"allOf":[{"$ref":"#/components/schemas/CreateParameterDefinitionRequest"}]}}}},"responses":{"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ParameterDefinition"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"500":{"description":"Internal Server Error"}}}}},"components":{"schemas":{"CreateParameterDefinitionRequest":{"required":["constraints","description","displayOrder","name","phase","scope","type"],"type":"object","properties":{"scope":{"minLength":1,"enum":["Agreement","Item","Subscription","Order","Asset"],"type":"string"},"phase":{"minLength":1,"enum":["Configuration","Order","Fulfillment"],"type":"string"},"context":{"enum":["None","Purchase","Change","Configuration","Termination"],"type":"string","nullable":true},"name":{"minLength":1,"type":"string"},"description":{"minLength":1,"type":"string"},"multiple":{"type":"boolean"},"externalId":{"type":"string","nullable":true},"displayOrder":{"type":"integer","format":"int32"},"constraints":{"allOf":[{"$ref":"#/components/schemas/Constraints"}]},"type":{"minLength":1,"enum":["SingleLineText","MultiLineText","Address","Contact","Checkbox","Choice","Subdomain","Heading","DropDown","Email","DataObject","Date"],"type":"string"},"options":{"type":"object","oneOf":[{"$ref":"#/components/schemas/AddressOptions"},{"$ref":"#/components/schemas/CheckboxOptions"},{"$ref":"#/components/schemas/ChoiceOptions"},{"$ref":"#/components/schemas/DataObjectOptions"},{"$ref":"#/components/schemas/ContactOptions"},{"$ref":"#/components/schemas/DateOptions"},{"$ref":"#/components/schemas/DropDownOptions"},{"$ref":"#/components/schemas/EmailOptions"},{"$ref":"#/components/schemas/HeadingOptions"},{"$ref":"#/components/schemas/MultiLineTextOptions"},{"$ref":"#/components/schemas/SingleLineTextOptions"},{"$ref":"#/components/schemas/SubdomainOptions"}]},"group":{"allOf":[{"$ref":"#/components/schemas/RequestObjectLink"}],"nullable":true}},"additionalProperties":false},"Constraints":{"type":"object","properties":{"hidden":{"type":"boolean","nullable":true},"readonly":{"type":"boolean","nullable":true},"required":{"type":"boolean","nullable":true},"capacity":{"allOf":[{"$ref":"#/components/schemas/CapacitySettings"}],"nullable":true}},"additionalProperties":false},"CapacitySettings":{"type":"object","properties":{"min":{"type":"integer","format":"int32"},"max":{"type":"integer","format":"int32"}},"additionalProperties":false},"AddressOptions":{"type":"object","properties":{"hintText":{"type":"string"},"defaultValue":{"allOf":[{"$ref":"#/components/schemas/DefaultParameterAddress"}]}},"additionalProperties":false},"DefaultParameterAddress":{"enum":["None","Buyer","Seller","Licensee"],"type":"string"},"CheckboxOptions":{"type":"object","properties":{"hintText":{"type":"string"},"optionsList":{"type":"array","items":{"$ref":"#/components/schemas/SelectionOption"}},"defaultValue":{"type":"array","items":{"type":"string"},"nullable":true}},"additionalProperties":false},"SelectionOption":{"type":"object","properties":{"label":{"type":"string"},"value":{"type":"string"},"description":{"type":"string","nullable":true}},"additionalProperties":false},"ChoiceOptions":{"type":"object","properties":{"hintText":{"type":"string"},"optionsList":{"type":"array","items":{"$ref":"#/components/schemas/SelectionOption"}},"defaultValue":{"type":"string","nullable":true}},"additionalProperties":false},"DataObjectOptions":{"type":"object","properties":{"hintText":{"type":"string"},"defaultValue":{"type":"string","nullable":true},"objectType":{"allOf":[{"$ref":"#/components/schemas/DataObjectType"}]}},"additionalProperties":false},"DataObjectType":{"enum":["Json","Xml"],"type":"string"},"ContactOptions":{"type":"object","properties":{"hintText":{"type":"string"},"defaultValue":{"allOf":[{"$ref":"#/components/schemas/DefaultParameterContact"}]},"phoneMandatory":{"type":"boolean"}},"additionalProperties":false},"DefaultParameterContact":{"enum":["None","CurrentlySignedInUser"],"type":"string"},"DateOptions":{"type":"object","properties":{"hintText":{"type":"string"},"dateRange":{"type":"boolean"},"minAvailableDate":{"type":"string","format":"date","nullable":true},"maxAvailableDate":{"type":"string","format":"date","nullable":true},"defaultValue":{"oneOf":[{"$ref":"#/components/schemas/RangeDateParameter"},{"type":"string"}],"nullable":true}},"additionalProperties":false},"RangeDateParameter":{"allOf":[{"$ref":"#/components/schemas/DateParameter"},{"type":"object","properties":{"start":{"type":"string","format":"date"},"end":{"type":"string","format":"date"}},"additionalProperties":false}]},"DateParameter":{"type":"object","additionalProperties":false},"DropDownOptions":{"type":"object","properties":{"hintText":{"type":"string"},"placeholderText":{"type":"string","nullable":true},"optionsList":{"type":"array","items":{"$ref":"#/components/schemas/BasicSelectionOption"}},"description":{"type":"string","nullable":true},"defaultValue":{"type":"string","nullable":true}},"additionalProperties":false},"BasicSelectionOption":{"type":"object","properties":{"label":{"type":"string"},"value":{"type":"string"}},"additionalProperties":false},"EmailOptions":{"type":"object","properties":{"placeholderText":{"type":"string"},"hintText":{"type":"string"},"defaultValue":{"allOf":[{"$ref":"#/components/schemas/DefaultParameterEmail"}]}},"additionalProperties":false},"DefaultParameterEmail":{"enum":["None","CurrentlySignedInUser"],"type":"string"},"HeadingOptions":{"type":"object","additionalProperties":false},"MultiLineTextOptions":{"type":"object","properties":{"placeholderText":{"type":"string"},"hintText":{"type":"string"},"minChar":{"type":"integer","format":"int32","nullable":true},"maxChar":{"type":"integer","format":"int32","nullable":true},"defaultValue":{"type":"string","nullable":true}},"additionalProperties":false},"SingleLineTextOptions":{"type":"object","properties":{"placeholderText":{"type":"string"},"hintText":{"type":"string"},"pattern":{"type":"string","nullable":true},"minChar":{"type":"integer","format":"int32","nullable":true},"maxChar":{"type":"integer","format":"int32","nullable":true},"defaultValue":{"type":"string","nullable":true}},"additionalProperties":false},"SubdomainOptions":{"type":"object","properties":{"placeholderText":{"type":"string"},"hintText":{"type":"string"},"domainSuffix":{"type":"string"}},"additionalProperties":false},"RequestObjectLink":{"type":"object","properties":{"id":{"type":"string"}},"additionalProperties":false},"ParameterDefinition":{"type":"object","properties":{"id":{"type":"string"},"audit":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectAudit"}]},"$meta":{"allOf":[{"$ref":"#/components/schemas/PlatformMetadata"}],"nullable":true},"name":{"type":"string"},"revision":{"type":"integer","format":"int32"},"description":{"type":"string"},"multiple":{"type":"boolean"},"externalId":{"type":"string","nullable":true},"displayOrder":{"type":"integer","format":"int32","nullable":true},"constraints":{"allOf":[{"$ref":"#/components/schemas/Constraints"}]},"options":{"nullable":true},"type":{"enum":["SingleLineText","MultiLineText","Address","Contact","Checkbox","Choice","Subdomain","Heading","DropDown","Email","DataObject","Date"],"type":"string"},"status":{"enum":["Active","Deleted"],"type":"string"},"group":{"type":"object","allOf":[{"$ref":"#/components/schemas/ParameterGroupRef"}]},"scope":{"enum":["Agreement","Item","Subscription","Order","Asset"],"type":"string"},"phase":{"enum":["Configuration","Order","Fulfillment"],"type":"string"},"context":{"enum":["None","Purchase","Change","Configuration","Termination"],"type":"string"},"product":{"allOf":[{"$ref":"#/components/schemas/Product"}]}},"additionalProperties":false},"PlatformObjectAudit":{"type":"object","properties":{"created":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectEvent"}],"nullable":true},"updated":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectEvent"}],"nullable":true}},"additionalProperties":false},"PlatformObjectEvent":{"type":"object","properties":{"at":{"type":"string","format":"date-time","nullable":true},"by":{"type":"object","allOf":[{"$ref":"#/components/schemas/PlatformIdentityRef"}]}},"additionalProperties":false},"PlatformIdentityRef":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"icon":{"type":"string","nullable":true},"revision":{"type":"integer","format":"int32"}},"additionalProperties":false},"PlatformMetadata":{"type":"object","properties":{"omitted":{"type":"array","items":{"type":"string"}}},"additionalProperties":false},"ParameterGroupRef":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"revision":{"type":"integer","format":"int32"}},"additionalProperties":false},"Product":{"type":"object","properties":{"id":{"type":"string"},"audit":{"allOf":[{"$ref":"#/components/schemas/ProductAudit"}]},"$meta":{"allOf":[{"$ref":"#/components/schemas/PlatformMetadata"}],"nullable":true},"name":{"type":"string"},"icon":{"type":"string","nullable":true},"revision":{"type":"integer","format":"int32"},"shortDescription":{"type":"string","nullable":true},"longDescription":{"type":"string","nullable":true},"externalIds":{"allOf":[{"$ref":"#/components/schemas/ProductExternalIdBag"}]},"website":{"type":"string"},"status":{"type":"string"},"vendor":{"allOf":[{"$ref":"#/components/schemas/Account"}]},"settings":{"allOf":[{"$ref":"#/components/schemas/ProductSettings"}]},"statistics":{"allOf":[{"$ref":"#/components/schemas/ProductStatistics"}]}},"additionalProperties":false},"ProductAudit":{"type":"object","properties":{"created":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectEvent"}],"nullable":true},"updated":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectEvent"}],"nullable":true},"published":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectEvent"}],"nullable":true},"pending":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectEvent"}],"nullable":true},"unpublished":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectEvent"}],"nullable":true}},"additionalProperties":false},"ProductExternalIdBag":{"type":"object","properties":{"operations":{"type":"string","nullable":true},"defaultErpItem":{"type":"string","nullable":true}},"additionalProperties":false},"Account":{"type":"object","properties":{"id":{"type":"string"},"audit":{"allOf":[{"$ref":"#/components/schemas/PlatformObjectAudit"}]},"$meta":{"allOf":[{"$ref":"#/components/schemas/PlatformMetadata"}],"nullable":true},"name":{"type":"string"},"icon":{"type":"string","nullable":true},"revision":{"type":"integer","format":"int32"},"type":{"allOf":[{"$ref":"#/components/schemas/AccountType"}],"nullable":true},"status":{"allOf":[{"$ref":"#/components/schemas/AccountStatus"}],"nullable":true},"externalIds":{"allOf":[{"$ref":"#/components/schemas/AccountExternalIds"}],"nullable":true},"externalId":{"type":"string","nullable":true},"externalName":{"type":"string","nullable":true},"address":{"allOf":[{"$ref":"#/components/schemas/Address"}]},"technicalSupportEmail":{"type":"string","nullable":true},"website":{"type":"string","nullable":true},"description":{"type":"string","nullable":true},"groups":{"type":"array","items":{"$ref":"#/components/schemas/UserGroupRef"},"nullable":true},"eligibility":{"allOf":[{"$ref":"#/components/schemas/Eligibility"}],"nullable":true},"defaultLanguageCode":{"type":"string","nullable":true}},"additionalProperties":false},"AccountType":{"enum":["Client","Vendor","Operations"],"type":"string"},"AccountStatus":{"enum":["Active","Enabled","Disabled"],"type":"string"},"AccountExternalIds":{"type":"object","properties":{"pyraTenantId":{"type":"string","format":"uuid","nullable":true}},"additionalProperties":false},"Address":{"type":"object","properties":{"addressLine1":{"type":"string","nullable":true},"addressLine2":{"type":"string","nullable":true},"postCode":{"type":"string","nullable":true},"city":{"type":"string","nullable":true},"state":{"type":"string","nullable":true},"country":{"type":"string","nullable":true}},"additionalProperties":false},"UserGroupRef":{"type":"object","properties":{"id":{"type":"string"},"name":{"type":"string"},"revision":{"type":"integer","format":"int32"},"description":{"type":"string","nullable":true},"logo":{"type":"string","nullable":true},"isDefault":{"type":"boolean"}},"additionalProperties":false},"Eligibility":{"type":"object","properties":{"client":{"type":"boolean"},"partner":{"type":"boolean"}},"additionalProperties":false},"ProductSettings":{"type":"object","properties":{"productOrdering":{"type":"boolean"},"productRequests":{"allOf":[{"$ref":"#/components/schemas/ProductRequestsSetting"}]},"itemSelection":{"type":"boolean"},"orderQueueChanges":{"type":"boolean"},"preValidation":{"allOf":[{"$ref":"#/components/schemas/PreValidationSettings"}]},"splitBilling":{"allOf":[{"$ref":"#/components/schemas/ProductSplitBillingRequestsSetting"}]},"sendCostToErp":{"type":"boolean","nullable":true},"subscriptionCessation":{"allOf":[{"$ref":"#/components/schemas/SubscriptionCessationSetting"}]}},"additionalProperties":false},"ProductRequestsSetting":{"type":"object","properties":{"enabled":{"type":"boolean"},"name":{"type":"string","nullable":true},"label":{"type":"string","nullable":true}},"additionalProperties":false},"PreValidationSettings":{"type":"object","properties":{"purchaseOrderDraft":{"type":"boolean"},"purchaseOrderQuerying":{"type":"boolean"},"changeOrderDraft":{"type":"boolean"},"configurationOrderDraft":{"type":"boolean"},"terminationOrder":{"type":"boolean"}},"additionalProperties":false},"ProductSplitBillingRequestsSetting":{"type":"object","properties":{"enabled":{"type":"boolean"},"type":{"type":"string","nullable":true}},"additionalProperties":false},"SubscriptionCessationSetting":{"type":"object","properties":{"enabled":{"type":"boolean"},"mode":{"enum":["Termination","Auto-renewal","Termination or auto-renewal"],"type":"string","nullable":true}},"additionalProperties":false},"ProductStatistics":{"type":"object","properties":{"itemCount":{"type":"integer","format":"int32"},"ordersPlacedCount":{"type":"integer","format":"int32"},"agreementCount":{"type":"integer","format":"int32"},"subscriptionCount":{"type":"integer","format":"int32"}},"additionalProperties":false},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```
